using System;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace MouseGesture_Net
{
	/// <summary>
	/// }EXWFX`̔s
	/// </summary>
	public class MouseGesture
	{
		/// <summary>
		/// 苗
		/// </summary>
		public int Range
		{
			
			get
			{
				return range;
			}
			set
			{
				range = value;
			}
		}
		
		/// <summary>
		/// }EXWFX`̗L
		/// </summary>
		private bool enable;
		
		/// <summary>
		/// 苗
		/// </summary>
		private int range;
		
		/// <summary>
		/// lꂼɂĂ̏(vf̑傫͂S)
		/// </summary>
		private Direction []direction;
		
		/// <summary>
		/// ړvZp̌Âʒu
		/// </summary>
		private Point old;

		public MouseGesture()
		{
			enable =false;
			direction =new Direction[4];
			for(int i =0;i<4;i++)
			{
				direction[i] =new Direction();
			}
			range = 15;
		}

		/// <summary>
		/// }EXWFX`̊Jn
		/// </summary>
		/// <param name="control">}EXWFX`̑ΏۂƂȂRg[</param>
		/// <param name="pos">݂̃}EXʒu</param>
		public void Start(Control control,Point pos)
		{
			enable =true;
			resetDirection();
			old =pos;
			SetCapture(control.Handle);
		}

		/// <summary>
		/// }EXWFX`̏I
		/// </summary>
		public void End()
		{
			if(enable)
			{
				enable =false;
				ReleaseCapture();
			}
		}

		/// <summary>
		/// }EXWFX`̔
		/// </summary>
		/// <param name="pos">}EẌʒu</param>
		/// <returns>WFX`</returns>
		public Arrow Test(Point pos)
		{	
			//LȂƂ肷B
			if(enable)
			{
				int ox = old.X,oy = old.Y;
				Arrow arrow = Arrow.none;
				
				//ւĂ
				old =pos;
		
				//ړʂ𔻒肵ďcǂɓ𔻒
				if(Math.Abs(ox - pos.X) > Math.Abs(oy - pos.Y))
				{
					if(ox > pos.X)
					{
						direction[(int)Arrow.left].Length += ox - pos.X;
						direction[(int)Arrow.right].Length = 0;
						arrow = Arrow.left;
					}
					else if(pos.X >ox)
					{
						direction[(int)Arrow.right].Length += pos.X - ox;
						direction[(int)Arrow.left].Length = 0;
						arrow = Arrow.right;
					}
				}
				else
				{
					if(oy > pos.Y)
					{
						direction[(int)Arrow.up].Length += oy - pos.Y;
						direction[(int)Arrow.down].Length = 0;
						arrow = Arrow.up;
					}
					else if(pos.Y >oy)
					{
						direction[(int)Arrow.down].Length += pos.Y - oy;
						direction[(int)Arrow.up].Length = 0;
						arrow = Arrow.down;
					}
				}
	
				//ړmƂ
				if(arrow != Arrow.none)
				{
					if(direction[(int)arrow].Enable &&
						direction[(int)arrow].Length > range)
					{
						resetDirection();
			
						//Qx͂Ȃ悤ɂB
						direction[(int)arrow].Enable=false;
					
						return arrow;
					}
				}
			}
			return Arrow.none;
		}

		/// <summary>
		/// S̏Zbg
		/// </summary>
		private void resetDirection()
		{
			for(int i=0;i<4;i++)
			{
				direction[i].Reset();
			}
		}
		@ 

		/// <summary>
		/// }EXLv`
		/// </summary>
		/// <param name="hwnd">̃EBhEnh</param>
		/// <returns>ȑO}EXLv`ĂEBhẼnh</returns>
		[DllImport("User32.dll")]
		private extern static IntPtr SetCapture(IntPtr hwnd);


		/// <summary>
		/// }EXLv`~߂
		/// </summary>
		/// <returns>OӊOƐ</returns>
		[DllImport("User32.dll")]
		private extern static bool ReleaseCapture();

		#region CCNX
		/// <summary>
		/// ̕Ɋւ
		/// </summary>
		public class Direction
		{
			/// <summary>
			/// L
			/// </summary>
			public bool Enable;
			
			/// <summary>
			/// ݌vړ
			/// </summary>
			public int Length;

			/// <summary>
			/// Zbg܂B
			/// </summary>
			public void Reset()
			{
				Enable = true;
				Length = 0;
			}

			public Direction()
			{
				Reset();
			}
		}	
		#endregion
	}
}
